%define	basefontdir	%{_datadir}/fonts/chinese
%define	ttfontdir	%{basefontdir}/TrueType
%define	miscfontdir	%{basefontdir}/misc
%define cidmapdir   %{_sysconfdir}/ghostscript

%define ver 0.1
%define minor 20060513
%define rhpatch rh20061130a
%define taipeiver 1.2

Summary:    Chinese TrueType Font -- Simplified and Traditional Chinese.
Name:		fonts-chinese
Version:    3.02
Release: 9.9.2AX
License:        Arphic Public License (GPL-like), Dong Wen Song is Distributable under Licenses
Group:		User Interface/X
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source1:    rfdw.ttf.tar.bz2
Source2:    taipeifonts-%{taipeiver}.tar.gz
Source3:    http://www.study-area.org/apt/firefly-font/fireflysung-1.3.0.tar.gz
Source4:    gbsn00lp.ttf
Source5:    gkai00mp.ttf
Source9:    taipeifonts.alias
Source20:	FAPIcidfmap.zh_TW
Source21:	FAPIcidfmap.zh_CN
Source22:	cidfmap.zh_TW
Source23:	cidfmap.zh_CN
Source24:	CIDFnmap.zh_TW
Source25:	CIDFnmap.zh_CN

Requires(post): ttmkfdir >= 3.0.6, mkfontdir, fontconfig, /usr/sbin/chkfontpath
Requires(postun): fontconfig, /usr/sbin/chkfontpath
BuildRequires: xorg-x11-font-utils
Obsoletes:	ttfonts-zh_CN ttfonts-zh_TW ttf-moe_sung ttf-moe_kai ttf-arphic_bming ttf-arphic_bkai taipeifonts

%description
Chinese TTF Fonts donated by Arphic company, with additional Hong Kong characters by Hong Kong font project and bitmap by Firefly. Read license files for details.
Simplified Chinese font is Dong Wen Song, it can support GB18030.

%prep
tar xzf %{SOURCE2}
tar xjf %{SOURCE1}

%build
mkdir -p %{name}-%{version}/doc
pushd taipeifonts-%{taipeiver}/
bdftopcf taipei24.bdf | gzip -c > taipei24.pcf.gz
bdftopcf taipei20.bdf | gzip -c > taipei20.pcf.gz
bdftopcf taipei16.bdf | gzip -c > taipei16.pcf.gz
popd

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{ttfontdir}
install -d $RPM_BUILD_ROOT%{miscfontdir}
install -d $RPM_BUILD_ROOT%{_datadir}/fonts/zh_CN/TrueType
install -d $RPM_BUILD_ROOT%{_datadir}/fonts/zh_TW/TrueType
install -m 0644 rfdw.ttf $RPM_BUILD_ROOT%{ttfontdir}/
install -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{ttfontdir}/
install -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{ttfontdir}/
(cd $RPM_BUILD_ROOT%{ttfontdir} && ln rfdw.ttf zysong.ttf)
install -m 644 taipeifonts-%{taipeiver}/taipei24.pcf.gz $RPM_BUILD_ROOT%{miscfontdir}
install -m 644 taipeifonts-%{taipeiver}/taipei20.pcf.gz $RPM_BUILD_ROOT%{miscfontdir}
install -m 644 taipeifonts-%{taipeiver}/taipei16.pcf.gz $RPM_BUILD_ROOT%{miscfontdir}
install -m 644 taipeifonts-%{taipeiver}/vga12x24.pcf.gz $RPM_BUILD_ROOT%{miscfontdir}
install -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{miscfontdir}/fonts.alias


# for ghostscript
install -d $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE20} $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE21} $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE22} $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE23} $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE24} $RPM_BUILD_ROOT%{cidmapdir}/
install -m 0644 %{SOURCE25} $RPM_BUILD_ROOT%{cidmapdir}/

# for dummy
touch $RPM_BUILD_ROOT%{basefontdir}/fonts.cache-1
touch $RPM_BUILD_ROOT%{ttfontdir}/fonts.cache-1
touch $RPM_BUILD_ROOT%{ttfontdir}/fonts.dir
touch $RPM_BUILD_ROOT%{ttfontdir}/fonts.scale
touch $RPM_BUILD_ROOT%{miscfontdir}/fonts.cache-1
touch $RPM_BUILD_ROOT%{miscfontdir}/fonts.dir
touch $RPM_BUILD_ROOT%{miscfontdir}/fonts.scale
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_CN/TrueType/rfdw.ttf
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_CN/TrueType/zysong.ttf
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_CN/TrueType/gbsn00lp.ttf
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_CN/TrueType/gkai00mp.ttf
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_TW/TrueType/bsmi00lp.ttf
touch $RPM_BUILD_ROOT%{_datadir}/fonts/zh_TW/TrueType/bkai00mp.ttf

#install firefly font
mkdir -p $RPM_BUILD_DIR/%{name}-%{version}/doc/
tar zxf %{SOURCE3} -C $RPM_BUILD_DIR/%{name}-%{version}/doc/
mv $RPM_BUILD_DIR/%{name}-%{version}/doc/fireflysung-1.3.0/fireflysung.ttf $RPM_BUILD_ROOT%{ttfontdir}/
(cd $RPM_BUILD_ROOT%{ttfontdir} && ln fireflysung.ttf ukai.ttf)
(cd $RPM_BUILD_ROOT%{ttfontdir} && ln fireflysung.ttf uming.ttf)

%clean
rm -rf $RPM_BUILD_ROOT

%post
{
	umask 133
	touch %{ttfontdir} 2> /dev/null && {
		/usr/bin/ttmkfdir -d %{ttfontdir} -o %{ttfontdir}/fonts.scale
	    mkfontdir %{ttfontdir}
		/usr/sbin/chkfontpath -q -a %{ttfontdir}
	}

	touch %{miscfontdir} 2> /dev/null && {
		/usr/bin/ttmkfdir -d %{miscfontdir} -o %{miscfontdir}/fonts.scale
	    mkfontdir %{miscfontdir}
		/usr/sbin/chkfontpath -q -a %{miscfontdir}
	}
	# make symlinks for java referring to old path and fonts
	ln -f %{_datadir}/fonts/chinese/TrueType/rfdw.ttf %{_datadir}/fonts/zh_CN/TrueType/rfdw.ttf || :
	ln -f %{_datadir}/fonts/chinese/TrueType/zysong.ttf %{_datadir}/fonts/zh_CN/TrueType/zysong.ttf || :
        ln -sf ../../chinese/TrueType/gbsn00lp.ttf %{_datadir}/fonts/zh_CN/TrueType/gbsn00lp.ttf || :
        ln -sf ../../chinese/TrueType/gkai00mp.ttf %{_datadir}/fonts/zh_CN/TrueType/gkai00mp.ttf || :
	ln -sf ../../chinese/TrueType/uming.ttf %{_datadir}/fonts/zh_TW/TrueType/bsmi00lp.ttf || :
        ln -sf ../../chinese/TrueType/ukai.ttf %{_datadir}/fonts/zh_TW/TrueType/bkai00mp.ttf || :
        touch /usr/share/fonts/zh_CN/TrueType 2>/dev/null && {
                /usr/bin/ttmkfdir -d /usr/share/fonts/zh_CN/TrueType -o /usr/share/fonts/zh_CN/TrueType/fonts.scale
                /usr/X11R6/bin/mkfontdir /usr/share/fonts/zh_CN/TrueType
                /usr/sbin/chkfontpath -q -a /usr/share/fonts/zh_CN/TrueType
        }
        touch /usr/share/fonts/zh_TW/TrueType 2>/dev/null && {
                /usr/bin/ttmkfdir -d /usr/share/fonts/zh_TW/TrueType -o /usr/share/fonts/zh_TW/TrueType/fonts.scale
                /usr/X11R6/bin/mkfontdir /usr/share/fonts/zh_TW/TrueType
                /usr/sbin/chkfontpath -q -a /usr/share/fonts/zh_TW/TrueType
        }

        #Update fontconfig cache
        [  -x /usr/bin/fc-cache ] && /usr/bin/fc-cache 2> /dev/null

}

%postun
if [ "$1" = 0 ];
then
    umask 133
    /usr/sbin/chkfontpath -q -r %{ttfontdir}
    /usr/sbin/chkfontpath -q -r %{miscfontdir}
    /usr/sbin/chkfontpath -q -r /usr/share/fonts/zh_CN/TrueType
    /usr/sbin/chkfontpath -q -r /usr/share/fonts/zh_TW/TrueType
    
    #Update fontconfig cache
    [ -x /usr/bin/fc-cache ] && /usr/bin/fc-cache 2> /dev/null
fi

%files
%defattr(-, root, root)
%doc $RPM_BUILD_DIR/%{name}-%{version}/doc/
%dir %{basefontdir}
%dir %{ttfontdir}
%dir %{miscfontdir}
%dir %{cidmapdir}
%{ttfontdir}
%{miscfontdir}
%dir %{_datadir}/fonts/zh_CN
%dir %{_datadir}/fonts/zh_TW
%dir %{_datadir}/fonts/zh_CN/TrueType
%dir %{_datadir}/fonts/zh_TW/TrueType
%ghost %verify(not md5 size mtime) %{basefontdir}/fonts.cache-1
%ghost %verify(not md5 size mtime) %{ttfontdir}/fonts.cache-1
%ghost %verify(not md5 size mtime) %{ttfontdir}/fonts.dir
%ghost %verify(not md5 size mtime) %{ttfontdir}/fonts.scale
%ghost %verify(not md5 size mtime) %{miscfontdir}/fonts.dir
%ghost %verify(not md5 size mtime) %{miscfontdir}/fonts.scale
%ghost %verify(not md5 size mtime) %{miscfontdir}/fonts.cache-1
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_CN/TrueType/rfdw.ttf
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_CN/TrueType/zysong.ttf
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_CN/TrueType/gbsn00lp.ttf
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_CN/TrueType/gkai00mp.ttf
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_TW/TrueType/bsmi00lp.ttf
%ghost %verify(not md5 size mtime) %{_datadir}/fonts/zh_TW/TrueType/bkai00mp.ttf
%{cidmapdir}/FAPIcidfmap.zh_TW
%{cidmapdir}/FAPIcidfmap.zh_CN
%{cidmapdir}/cidfmap.zh_TW
%{cidmapdir}/cidfmap.zh_CN
%{cidmapdir}/CIDFnmap.zh_TW
%{cidmapdir}/CIDFnmap.zh_CN

%changelog
* Tue Jun 19 2007 Shu Li <shuli@redflag-linux.com> - 3.02-9.9.2AX
- modify hard links instead of symbolic links in zh_CN document

* Wed Jun 06 2007 Xiao Liu <xiaoliu@redflag-linux.com> - 3.02-9.9.1AX
- del Source#6 because we do not use this fonts management and it
  is for zhongyi song
- add two chinese fonts and create fonts.dir in zh_CN and zh_TW
- for some java programs .
- add rfdw.ttf and create a hard link for zysong.ttf
- use firefly font for zh_TW
- create hard link for ukai.ttf and uming.ttf

* Thu May 03 2007 Caius Chance <cchance@redhat.com> - 3.02-9.9.el5
- Resolves: rhbz#223228
- bz#223228: LTC31115-Cannot display 4-bytes GB18030 characters on GB18030 
　locale.

* Mon Apr 16 2007 Caius Chance <cchance@redhat.com> - 3.02-9.8.el5
- Resolves: rhbz#220985
- bz#220985: LTC30501-Missing files in Traditional Chinese font support package.
             (Fixed mkfontdir typo error for misc font dir in post section.)

* Thu Feb 01 2007 Caius Chance <cchance@redhat.com> - 3.02-9.7.el5
- Resolves: rhbz#220985
- bz#220985: LTC30501-Missing files in Traditional Chinese font support package.

* Mon Jan 08 2007 Caius Chance <cchance@redhat.com> - 3.02-9.6.el5
- Resolves: rhbz#220291 rhbz#220985
- bz#220291: It doesn't clean the related folder and files when downgrade or
  remove package. (Regression fix)
- bz#220985: LTC30501-Missing files in Traditional Chinese font support package.

* Thu Dec 21 2006 Caius Chance <cchance@redhat.com> - 3.02-9.5.el5
- Resolves: rhbz#220291
- bz#220291: It doesn't clean the related folder and files when downgrade or
  remove package.

* Fri Dec 15 2006 Caius Chance <cchance@redhat.com> - 3.02-9.4.el5
- Resolves: rhbz#219580
- bz#219580: Added zh_TW as well instead of just zh_CN.

* Thu Dec 14 2006 Caius Chance <cchance@redhat.com> - 3.02-9.el5
- Resolves: rhbz#219580
- bz#219580: Cannot use Chinese fonts on Java application with JRE.

* Thu Nov 30 2006 Akira TAGOH <tagoh@redhat.com> - 3.02-8
- remove U+2022 to fallback to other fonts so that it's too wide for password
  input. (#216099)
- add CIDFnmap.zh_* (#215978)

* Tue Aug 29 2006 Caius Chance <cchance@redhat.com> - 3.02-7%{?dist}
- updated arphic uming and ukai fonts, re-patched with bz#197207.

* Wed Aug 23 2006 Caius Chance <cchance@redhat.com> - 3.02-6.el5
- fix bz#197207 - ")" glyph cutting in uming.ttf

* Thu Aug 03 2006 Caius Chance <cchance@redhat.com> - 3.02-5.el5
- inclusion of zhong yi song font

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 3.02-4.1.1
- rebuild

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Nov 17 2005 Warren Togami <wtogami@redhat.com> - 3.02-4
- req(foo,bar) syntax breaks erasure ordering

* Tue Nov 15 2005 Jeremy Katz <katzj@redhat.com> - 3.02-3
- fix mkfontdir call

* Tue Nov 15 2005 Warren Togami <wtogami@redhat.com> - 3.02-2
- use less fragile way to call mkfontdir

* Tue Nov 15 2005 Leon Ho <llch@redhat.com> - 3.02-1
- migrate taipeifonts to this package

* Mon Nov 14 2005 Warren Togami <wtogami@redhat.com> - 3.01-3
- rebuild against modular X

* Wed Nov 09 2005 Leon Ho <llch@redhat.com> - 3.01-2
- updated to use which to search for mkfontdir
- update to Requires: mkfontdir.

* Mon Nov 07 2005 Leon Ho <llch@redhat.com> - 3.01-1
- update uming and ukai to 0.1-0.dot.3

* Fri Sep 02 2005 Leon Ho <llch@redhat.com> - 3.00.pre2-1
- Upgrade to pre2 fonts

* Thu Aug 17 2005 Leon Ho <llch@redhat.com> - 3.00.pre1-1
- Move to uMing and uKai with HKSCS and Bitmap glyphs
- combined FAPIcidfmap.{zh_TW,zh_CN} into FAPIcidfmap.zh

* Tue Aug 16 2005 Akira TAGOH <tagoh@redhat.com> - 2.15-4
- Added cidfmap.zh_CN and cidfmap.zh_TW for the latest ghostscript.

* Thu Jul 14 2005 Akira TAGOH <tagoh@redhat.com> - 2.15-3
- use FAPIcidfmap instead of CIDFnmap for gs8.

* Wed Apr 20 2005 Akira TAGOH <tagoh@redhat.com> - 2.15-2
- Updated the font path in CIDFnmap.{zh_CN,zh_TW} (John Thacker, #155404)

* Thu Feb 24 2004 Leon Ho <llch@redhat.com>
- merge from ttfonts-zh_CN and ttfonts-zh_TW
